# coding: UTF-8

'''
pip install DingtalkChatbot
'''
# 2019/7/22 created by dadu

from dingtalkchatbot.chatbot import DingtalkChatbot
import time
from common.Excel import Reader
import sys,os

runTime = time.strftime('%Y-%m-%d %H:%M:%S')

#created by 2019/7/24
def findModuleName(arr,str):
    for index in range (len(arr)):
        if str == arr[index]:
            return 1
    return 0

#https://oapi.dingtalk.com/robot/send?access_token=1ffb37a991040d9d58bc3e967fa563e379db22c448fd7440f747cd4c44d4db26
def findGroupDingAddr(str):
    enterGroupModule = ["gic-store-service","gic-store-web","gic-store-web"]
    memberGroupModule = ["g2Test1","g2Test2"]
    marketGroupModule = ["api-open"]
    haobanGruupModule = ["g4Test1","g4Test2"]
    enterGroupDingAddr = 'https://oapi.dingtalk.com/robot/send?access_token=1ffb37a991040d9d58bc3e967fa563e379db22c448fd7440f747cd4c44d4db26'
    memberGroupDingAddr = 'https://oapi.dingtalk.com/robot/send?access_token=2656a52b44f1e2d9ebbf5e57560b5a7c2619dc07cec35c62d19b8b252e24a064'
    marketGroupDingAddr = 'https://oapi.dingtalk.com/robot/send?access_token=3e8fac3b110012fa44ae42235323deba5102fc439b62d87b7491c838b1948470'
    haobanGruupDingAddr = 'https://oapi.dingtalk.com/robot/send?access_token=2656a52b44f1e2d9ebbf5e57560b5a7c2619dc07cec35c62d19b8b252e24a064'
    err = "no group can be match,please check it"
    if findModuleName(enterGroupModule,str) == 1:
        return enterGroupDingAddr
    elif findModuleName(memberGroupModule,str) == 1:
        return memberGroupDingAddr
    elif findModuleName(marketGroupModule,str) == 1:
        return marketGroupDingAddr
    elif findModuleName(haobanGruupModule,str) == 1:
        return haobanGruupDingAddr
    else :
        print(err)
        return 0

def resultTextFalse(reporturl,str):
    # path = 'D:/workSpace/Python_workspace/apitest2.0_1.xls'   # for local
    path = '/opt/apitest/apiAutoByJenkins/repot/apitest1.xls'  # for server
    if os.path.exists(path):
        readExp = Reader()
        arrExpSingle = readExp.api_result(path)
        # print(arrExpSingle)
        expMsg = '\n'.join(arrExpSingle)
        if(findGroupDingAddr(str)!=0):
            groupDing = DingtalkChatbot(findGroupDingAddr(str))
            groupDing.send_text(msg = "接口自动化执行异常结果\n执行时间："+ runTime+ "\n执行异常接口列表：\n"+expMsg+"\n详细结果地址："+reporturl)
        else:
            sys.exit(0)
    else :
        print("resultFile is not exist,please check it")
        sys.exit(0)

def resultTextPass(reporturl,str):
    if(findGroupDingAddr(str)!=0):
        groupDing = DingtalkChatbot(findGroupDingAddr(str))
        groupDing.send_text(msg = "接口自动化执行无误\n执行时间："+ runTime+ "\n详细结果地址："+reporturl)
    else :
        sys.exit(0)

def msgSend(passrate,reporturl,str):
    #print(str)
    if float(passrate)==100.00:
        resultTextPass(reporturl,str)
    else :
        resultTextFalse(reporturl,str)



