# coding: UTF-8

from dingtalkchatbot.chatbot import DingtalkChatbot
import time
from common.Excel import Reader
import sys,os

qaTeamWebhook = 'https://oapi.dingtalk.com/robot/send?access_token=2656a52b44f1e2d9ebbf5e57560b5a7c2619dc07cec35c62d19b8b252e24a064'
qaTeamDing = DingtalkChatbot(qaTeamWebhook)
runTime = time.strftime('%Y-%m-%d %H:%M:%S')

# 钉钉推送消息异常
def resultTextFalse(reporturl):
	# 读取excel，获取到异常接口
	# pathSingle = 'D:/workSpace/Python_workspace/apitest2.0_1.xls'  # for local
	# pathMulti = 'D:/workSpace/Python_workspace/testcase2.0_1.xls' # for local
	pathSingle = '/opt/apitest/apiAutoByJenkins/repot/caseForJenkins/apitest1.xls'   # for server
	pathMulti = '/opt/apitest/apiAutoByJenkins/repot/caseForJenkins/testcase1.xls' #for server
	# 判断文件是否存在
	if (os.path.exists(pathSingle) or os.path.exists(pathMulti)):
		readExp = Reader()
		# 获取异常接口列表
		arrExpSingle = readExp.api_result(pathSingle)
		arrExpMulti = readExp.api_result(pathMulti)
		# 处理钉钉推送信息格式
		expSingleMsg = '\n'.join(arrExpSingle)
		expMultiMsg = '\n'.join(arrExpMulti)
		# 钉钉消息推送
		qaTeamDing.send_text(msg = "接口自动化执行异常结果\n执行时间："+ runTime+ "\n执行异常接口列表：\n"+expSingleMsg+"\n"+expMultiMsg+"\n详细结果地址："+reporturl)
	else :
		print("resultFile is not exist,please check it")
		qaTeamDing.send_text(msg = "接口自动化执行异常结果\n执行时间："+ runTime+ "\n详细结果地址："+reporturl)

# 钉钉推送正常消息，后期不推送
def resultTextPass(reporturl):
	qaTeamDing.send_text(msg = "接口自动化执行无误\n执行时间："+ runTime+ "\n详细结果地址："+reporturl)

# 钉钉消息推送入口
def msgSend(passrate,reporturl):
	if float(passrate)==100.00:
		resultTextPass(reporturl)
	else :
		resultTextFalse(reporturl)