"""
    by LiangChao
    at 2019/7/31
    用来执行多接口流程用例文件
    """
from common.Http import Http
from common.Excel import Reader, Writer
import unittest
import json, ddt, textwrap
http = Http()
reader = Reader()
writer = Writer()
# 读取用例文件
# reader.open_excle('D:/workSpace/Python_workspace/testcase2.0.xls') # for local
reader.open_excle('/opt/apitest/apiAutoByJenkins/repot/caseForJenkins/testcase.xls')  # for server
sheetname = reader.get_sheets()
# copy用例文件
# writer.copy_open('D:/workSpace/Python_workspace/testcase2.0.xls', 'D:/workSpace/Python_workspace/testcase2.0_1.xls') # for local
writer.copy_open('/opt/apitest/apiAutoByJenkins/repot/caseForJenkins/testcase.xls', '/opt/apitest/apiAutoByJenkins/repot/caseForJenkins/testcase1.xls')  # for server
sheetname1 = writer.get_sheets()
writer.set_sheet(sheetname1[0])
for sheet in sheetname:
    # 设置当前读取的sheet页面
    reader.set_sheet(sheet)
    data = reader.dict_data()
    #print(data)
@ddt.ddt
class Run(unittest.TestCase):
    @classmethod
    def setUp(self):
        pass
    def runner(self,line,http):
        d = {
            "Post": [line[4], line[5], line[6], line[7], line[8]],
            "Addheader": [line[4]],
            "savejson": [line[4], line[5]],
            "clear_values": [],
            "Url": [line[4]],
            "Addjson": [line[4], line[5]],
            "Database_query": [line[4], line[5], line[6]],
            "Get": [line[4], line[5], line[6], line[7], line[8]],
            "Parameter":[line[4]]
        }
        if len(line[0])>0 or len(line[1])>0:
            return
        if hasattr(http, line[3]):
            func = getattr(http, line[3])
            for k, v in d.items():
                if line[3] in k:
                    result = func(*v)
                    return result
    @ddt.data(*data)
    def test_run(self,data):
        # 用例执行
        excle_value = reader.readline_new(data[-1])
        result = self.runner(excle_value, http)
        if result != None:
            if isinstance(result, tuple):
                results = json.dumps(result[0])
                if result[1][0] == result[1][1]:
                    writer.write(data[-1], 9, 'pass')
                else:
                    writer.write(data[-1], 9, 'fail')
                incol = 10
                for var in textwrap.wrap(text=results, width=30000):
                    writer.write(data[-1], incol, var)
                    incol = incol +1
                try:
                    self.assertEqual(result[1][0], result[1][1], msg='\n检验的字段名称:{}\n请求的接口api:{}'.format(excle_value[7], excle_value[4]))
                except AssertionError as e:
                    print("实际与预期不符:{}\n接口返回结果:\n{}".format(e, result[0]))
                    #print("实际与预期不符:{}\n接口返回结果:\n".format(e))
                    raise
                print(result[0])
                # 写入Excel文件
            else:
                print(result)
                results = json.dumps(result)
                # 写入Excel文件
                writer.write(data[-1], 9, 'pass')
                writer.write(data[-1], 10, results)
                #writer.save_close()
    def tearDown(self):
        # 保存文件
        writer.save_close()

if __name__ == '__main__':
    run = Run()
    run.test_run()